/**
 *
 */
package de.intevation.gnv.transition;

import java.util.ArrayList;
import java.util.Collection;

import org.apache.log4j.Logger;

import de.intevation.gnv.geobackend.base.Result;
import de.intevation.gnv.transition.describedata.DefaultMinMaxDescribeData;
import de.intevation.gnv.transition.describedata.DescribeData;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 * 
 */
public class MinMaxTransition extends TransitionBase {

    /**
     * The UID of this Class
     */
    private static final long serialVersionUID = -3525903792105187408L;
    /**
     * the logger, used to log exceptions and additonaly information
     */
    private static Logger log = Logger.getLogger(MinMaxTransition.class);

    /**
     * Constructor
     */
    public MinMaxTransition() {
        super();
    }

    /**
     * @see de.intevation.gnv.transition.TransitionBase#purifyResult(java.util.Collection,
     *      java.lang.String)
     */
    @Override
    protected void purifyResult(Collection<Result> result, String uuid) {
        log.debug("MinMaxTransition.purifyResult");
        Collection<Object> describeData = this.getDescibeData(uuid);
        if (describeData == null) {
            describeData = new ArrayList<Object>();
        }
        if (result != null && result.size() == 1) {

            String minName = this.dataName;
            String maxName = this.dataName;
            Result value = result.iterator().next();
            DescribeData values = new DefaultMinMaxDescribeData(minName,
                    maxName, value.getObject("MIN"), value.getObject("MAX"));
            log.debug(values.toString());
            describeData.add(values);
        } else {
            log.warn("Result cannot be handled as MinMax Resultset");
        }
        this.setDescibeData(uuid, describeData);
    }

    /**
     * @see de.intevation.gnv.transition.Transition#validate()
     */
    public boolean validate() {
        // TODO: Implement ME
        return true;
    }

}
